/*datos.cpp */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "datos.h"

Datos::Datos()
{
  n=0;
  i=0;
}

void Datos::vaciar()
{
  Item *j;

  while(n--)
  {
    j=i;
    i=i->siguiente();
    delete j;
  }
  n=0;
  i=0;
}

static void leerLinea(FILE *f,char *buffer,char *&k,char *&p,char *&t)
{
  char *pt;

  if(!fgets(buffer,255,f)) return;
  pt=buffer;
  while(*pt && *pt == ' ') p++;
  if (!*pt) return;
  k=pt;
  while(*pt && (*pt != '/' || *(pt+1)!='/')) pt++;
  if (!*pt) return;
  *pt=0;
  pt +=2;
  p=pt;
  while(*pt && (*pt != '/' || *(pt+1)!='/')) pt++;
  if (!*pt) return;
  *pt=0;
  pt +=2;
  t=pt;
  while(*pt && *pt!=10 && *pt!=13 &&(*pt != '/' || *(pt+1)!='/')) pt++;
  *pt=0;
}

int Datos::numero()
{
  return n;
}

void Datos::barajar()
{
int j,k;
Palabra *aux;

if(n<3) return;
  srand(time(0));
  for(j=0;j<n*10;j++)
  {
    if((rand()%4)>2)
    {
      aux=i->palabra();
      i->palabra(i->siguiente()->palabra());
      i->siguiente()->palabra(aux);
    }
    for(k=0;k<(rand()%n);k++)
      rotar();
  }
}

void Datos::leerFichero(char *fichero)
{
  FILE *f;
  char *k,*p,*t;
  char buffer[256];
  Item *ultimo=0;
  vaciar();
  f=fopen(fichero,"r");
  while(!feof(f))
  {
    k=p=t=0;
    leerLinea(f,buffer,k,p,t);
    if( k && p && t)
    {
      i=new Item(k,p,t,i);
      if(ultimo==0) ultimo=i;
      n++;
    }
  }
  ultimo->siguiente(i);
  fclose(f);
  barajar();
}

void Datos::rotar()
{
  i=i->siguiente();
}

char *Datos::hanzi()
{
   return i->palabra()->hanzi();
}

char *Datos::pinyin()
{
   return i->palabra()->pinyin();
}

char *Datos::traduccion()
{
   return i->palabra()->traduccion();
}

Datos::~Datos()
{
  vaciar();
}
